# tumelune

a Thing to search in archived Posts

it imports twitter and mastodon exported archives and lets you browse and search in it with a web interface

![screenshot](screenshot.png)

### building from source
```
# it needs rustc/cargo.
# you can install it with os packages:
#    arch: pacman -S rust
#    deb:  apt install cargo
# or through rustup:
#    url:  https://rustup.rs/
#    arch: pacman -S rustup
# with
#    rustup toolchain install stable

cargo run --release
```

### some functional notes

- it was made to aggregate and search over all my social media archives.
  tumelune is thus optimized to load many archives of the same or multiple accounts,
  twitter or mastodon, and navigate the full data set ignoring duplicates.
- until tantivy stabilizes or we keep another database in parallel,
  it tends to lose data on updates. always keep your archives

### there's a CLI if you even care
```
# import an archive
  ./tumelune import archive.tar.gz
  ./tumelune import archive.zip
# start the web ui (it's nice)
  ./tumelune serve --listen 127.0.0.1:29804 --open
  or just ./tumelune
# cli search (it's not great but it exists)
  ./tumelune search cats
```

### some technical notes

- the 'main interface' is a web application served by a rust package.  
    it's meant to run locally and avoid strict dependencies on a gui library without being limited by a command line interface.
    archives are uploaded to the backend over http or read from a local file directly.
- the rust back end unpacks, stores, indexes data archives, and serves it with search and pagination.
- the web front end queries that and displays a result list.  
    it's written at the interection of plainest and messiest javascript.  
    i have never heard of this 'npm' and the whole thing has been written as organically as possible with a short term memory of about ten seconds
- key words from posts are extracted and indexed (in rust), but the source material is stored as is and parsed on display (in javascript).
    attachments are extracted and stored as individual files
- the two sides could be merged in wasm but tantivy isnt ready for it yet.  
    so it looks and works like web 2.0 in a complicated box and i find that neat.
- it does not bundle a browser because that makes builds and distribution a lot more complicated and brittle and demanding in resources.
  plus you most likely already have one or three good browsers around. maybe some day i will like tauri
- you could host a public instance too if you wanted. but everyone is sharing write access to the same index.
