window.addEventListener("load", function() {
    let tumelune = document.querySelector("h1 .tumelune");
    const lune = document.querySelector("h1 .lune");
    const version = document.querySelector("h1 .version");
    let build_time = null;

    const tumelune_text = tumelune.innerText;

    function build_canvas() {
        // make a canvas of tumelune's exact size and replace the span by the canvas
        // on it a rendered text with all the fancy shit we want to do
        var canvas = document.createElement("canvas");
        canvas.onclick = build_canvas;
        canvas.classList.add("tumelune");
        canvas.width = tumelune.offsetWidth;
        canvas.height = tumelune.offsetHeight;
        var ctx = canvas.getContext('2d');

        ctx.fillStyle = "#bdbde6";
        ctx.font = "64px 'Fondamento'";
        ctx.fillText(tumelune_text, 0, (canvas.height / 2) + 24);

        tumelune.parentNode.replaceChild(canvas, tumelune);
        tumelune = canvas;

        // a w*h*3 size array of 2 random values and one empty register per box
        var mask = new Array();
        const ms = 3;
        for (var x=0; x<canvas.width/ms; x++) {
            for (var y=0; y<canvas.height/ms; y++) {
                mask.push(Math.random());
                mask.push(Math.random());
                mask.push(0);
            }
        }

        id = ctx.getImageData(0, 0, canvas.width, canvas.height);
        for (var x=0; x<canvas.width; x++) {
            for (var y=0; y<canvas.height; y++) {
                const offset = (y * canvas.width + x) * 4;
                const offsetM = (Math.ceil(y/ms) * Math.ceil(canvas.width/ms) + Math.ceil(x / ms)) * 3;
                id.data[offset + 0] = 40 + Math.round(mask[offsetM + 0] * 170);
                id.data[offset + 1] = 40 + Math.round(mask[offsetM + 1] * 160);
                id.data[offset + 2] = 255;

                mask[offsetM + 2] |= id.data[offset + 3];
                id.data[offset + 3] |= mask[offsetM + 2];
            }
        }
        ctx.putImageData(id, 0, 0);

        build_time = Date.now();
    }
    build_canvas();
    setInterval(function() {
        if (Date.now() - build_time < 5000) {
            return;
        }
        build_canvas()
    }, 5000);
});
